#!/usr/bin/guile-2.2 \
-e main -s
!#


;; Copyright (C) 2019 Tommi Höynälänmaa
;; Distributed under GNU General Public License version 3,
;; see file doc/GPL-3.


(import (theme-d common theme-d-config))
(import (theme-d testing test-info))
	

(init-theme-d-config)

(define gl-theme-d-run-path
  (get-theme-d-config-var 'run-path))


(define gl-log-filename "run-test-programs.log")


(define (get-str-test-name i)
  (string-append "test" (number->string i)))


(define (get-test-filename i)
    (string-append (get-str-test-name i) ".rkt"))


(define (get-test-path i)
  (let ((filename (get-test-filename i)))
    (string-append "../theme-d-code/tests/" filename)))


(define (run-tests log-file)
  (do ((i 1 (+ i 1))) ((> i nr-of-tests))
    (if (and (not (member i no-run))
	     (not (member i modules))
	     (not (member i custom2-programs))
	     (not (member i guile-hashtable-units))
	     (not (member i extra-math-units)))
	(let ((path (get-test-path i))
	      (filename (get-test-filename i)))
	  (display filename log-file)
	  (display ": " log-file)
	  (display "Starting test ")
	  (display i)
	  (newline)
	  (let ((str-cmd
		 (if (not (member i scripts))
		     (string-append "racket -t " path " -m")
		     (string-append "racket -t " path))))
	    (if (= (system str-cmd) 0)
		(display "ok" log-file)
		(display "error" log-file)))
	  (display "Finished test ")
	  (display i)
	  (newline)
	  (newline log-file)))))


(define (main args)
  (let ((log-file (open-output-file gl-log-filename)))
    (run-tests log-file)
    (close log-file)))
